@echo off
cls

echo PL-X51P,PL-X52P Utility Installation is in progress... 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Begin localizations of subsequent environment changes in this script
setlocal ENABLEDELAYEDEXPANSION

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Checking the required installation files

IF NOT EXIST .\Miscellaneous\Setup.exe goto FileMissing
IF NOT EXIST .\Miscellaneous\PL-X51P_PL-X52P_Utility_Setup.msi goto FileMissing
IF NOT EXIST .\Miscellaneous\Setup.Ini goto FileMissing
IF NOT EXIST .\Miscellaneous\WinPcap_4_1_2.exe goto FileMissing
IF NOT EXIST .\Miscellaneous\InstMsiA.Exe goto FileMissing
IF NOT EXIST .\Miscellaneous\InstMsiW.Exe goto FileMissing
IF NOT EXIST .\Miscellaneous\dynwrapx.dll goto FileMissing

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Read the installated version of WinPcap from registry in a variable
echo Option Explicit >> InstallWinPcap.vbs
echo 'On Error Resume Next >> InstallWinPcap.vbs
echo Dim strSystemOSPath, strValueID, CPIdentifier, Is32bitOS >> InstallWinPcap.vbs
echo Dim strKeyPath, strValueName, strValue, versionString, strValueName1, uninstallPath, msgString, IfInstallWinPcap, errString, IfFileMissing, Flag >> InstallWinPcap.vbs
echo Dim strNetKeyPath, DotNetVersion, strNetValueName, NetversionString, strNetValueName1, NetmsgString, IfInstallDotNet, NeterrString, IfDotNetFileMissing, NetFlag >> InstallWinPcap.vbs
echo Dim strComputer, oReg >> InstallWinPcap.vbs
echo Dim wshNetwork, strUser >> InstallWinPcap.vbs
echo Dim objShell, NetobjShell, spath, path, Netspath, Netpath >> InstallWinPcap.vbs
echo Dim oFSO , NetoFSO >> InstallWinPcap.vbs
echo Dim oMB >> InstallWinPcap.vbs
echo const HKEY_LOCAL_MACHINE = ^&H80000002 >> InstallWinPcap.vbs
echo strComputer = "." >> InstallWinPcap.vbs
echo Set wshNetwork = CreateObject("WScript.Network") >> InstallWinPcap.vbs
echo strUser = wshNetwork.Username >> InstallWinPcap.vbs
echo Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" ^&_  >> InstallWinPcap.vbs
echo strComputer ^& "\root\default:StdRegProv") >> InstallWinPcap.vbs

:: Register dynwrapx.dll
regsvr32.exe /s /i .\Miscellaneous\dynwrapx.dll

echo Set oMB = CreateObject("DynamicWrapperX") >> InstallWinPcap.vbs
echo oMB.Register "user32.dll", "MessageBoxW", "i=hwwu", "r=l" >> InstallWinPcap.vbs

:: This function is unicode compliant to display a MsgBox in any language
:: It relies in the dynwrapx.dll to be registered
echo Function APIMsgBox(sMsg, sBut, sTitle) >> InstallWinPcap.vbs
echo APIMsgBox = oMB.MessageBoxW(0, sMsg, sTitle, sBut) >> InstallWinPcap.vbs
echo End Function  >> InstallWinPcap.vbs

 ::Get the OS version, whether 32bit or 64bit
echo strSystemOSPath = "HARDWARE\DESCRIPTION\System\CentralProcessor\0" >> InstallWinPcap.vbs
echo strValueID = "Identifier" >> InstallWinPcap.vbs
echo oReg.GetStringValue HKEY_LOCAL_MACHINE, strSystemOSPath, strValueID, CPIdentifier >> InstallWinPcap.vbs
echo IF InStr(1, CPIdentifier, "x86") = 0 Then >> InstallWinPcap.vbs
echo '64bit >> InstallWinPcap.vbs
echo 	Is32bitOS = 1 >> InstallWinPcap.vbs
echo Else>> InstallWinPcap.vbs
echo '32bit >> InstallWinPcap.vbs
echo 	Is32bitOS = 0 >> InstallWinPcap.vbs
echo End If >> InstallWinPcap.vbs

::Get the version of WinPcap if installed
echo IF Is32bitOS = "0" Then>> InstallWinPcap.vbs
echo 	strKeyPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\WinPcapInst" >> InstallWinPcap.vbs
echo Else>> InstallWinPcap.vbs
echo 	strKeyPath = "SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\WinPcapInst" >> InstallWinPcap.vbs
echo End If >> InstallWinPcap.vbs
echo strValueName = "DisplayVersion" >> InstallWinPcap.vbs
echo strValueName1 = "DisplayIcon" >> InstallWinPcap.vbs
echo oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName, versionString >> InstallWinPcap.vbs
echo oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName1, uninstallPath >> InstallWinPcap.vbs

echo Flag = True >> InstallWinPcap.vbs
echo IF versionString = "4.1.0.2001" Then >> InstallWinPcap.vbs
echo 	Flag = False >> InstallWinPcap.vbs
echo Else >> InstallWinPcap.vbs
echo 	Set objShell = WScript.CreateObject("WScript.Shell") >> InstallWinPcap.vbs
echo 	spath = objShell.CurrentDirectory >> InstallWinPcap.vbs

echo 	path = """" ^& spath ^& ".\Miscellaneous\WinPcap_4_1_2.exe" ^& "" >> InstallWinPcap.vbs

echo   Set oFSO = CreateObject("scripting.FileSystemObject") >> InstallWinPcap.vbs
echo   If oFSO.FileExists(".\Miscellaneous\WinPcap_4_1_2.exe") = True Then >> InstallWinPcap.vbs
echo      'Do Nothing >> InstallWinPcap.vbs
echo   Else >> InstallWinPcap.vbs
echo 		errString = "WinPcap_4_1_2.exe not found. Please copy WinPcap_4_1_2.exe properly before proceeding."  >> InstallWinPcap.vbs
echo 		IfFileMissing = APIMsgBox(errString, 0, "File Missing") >> InstallWinPcap.vbs
echo 		IF IfFileMissing = "1" Then >> InstallWinPcap.vbs
echo			WScript.Quit >> InstallWinPcap.vbs
echo 		End If >> InstallWinPcap.vbs
::echo 	Else >> InstallWinPcap.vbs
::echo 		'Do nothing >> InstallWinPcap.vbs
echo 	End If >> InstallWinPcap.vbs
echo. End If >> InstallWinPcap.vbs
echo.
::if WinPcap is not already installed, ask user if he wants to install WinPcap on system or not
echo IF Flag = True Then >> InstallWinPcap.vbs
echo 	msgString = "WinPcap Software (version 4.1.2) is either not installed or some previous version is already installed on this workstation. The WinPcap (version 4.1.2) installer is being launched. Please follow the instructions for installing the WinPcap software" >> InstallWinPcap.vbs
echo 	IfInstallWinPcap = APIMsgBox(msgString, 1, "WinPcap Installation") >> InstallWinPcap.vbs
echo.
echo 	IF IfInstallWinPcap = "1" Then >> InstallWinPcap.vbs
::User pressed "Yes"
echo 		objShell.Run path, 0, True >> InstallWinPcap.vbs
echo 	Else >> InstallWinPcap.vbs
::User pressed "No"
echo		'Do nothing >> InstallWinPcap.vbs
echo 	End If >> InstallWinPcap.vbs
echo End If >> InstallWinPcap.vbs


:: Check for .Net Framework v2 and install the framework

echo IF Is32bitOS = "0" Then>> InstallWinPcap.vbs
echo 	strNetKeyPath = "SOFTWARE\Microsoft\NET Framework Setup\NDP\v2.0.50727" >> InstallWinPcap.vbs
echo Else>> InstallWinPcap.vbs
echo 	strNetKeyPath = "SOFTWARE\Microsoft\NET Framework Setup\NDP\v2.0.50727" >> InstallWinPcap.vbs
echo End If >> InstallWinPcap.vbs
echo strNetValueName = "SP" >> InstallWinPcap.vbs
echo strNetValueName1 = "DisplayIcon" >> InstallWinPcap.vbs
echo oReg.GetDWORDValue HKEY_LOCAL_MACHINE, strNetKeyPath, strNetValueName, NetversionString >> InstallWinPcap.vbs
echo oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName1, uninstallPath >> InstallWinPcap.vbs
	
echo NetFlag = True >> InstallWinPcap.vbs
echo IF NetversionString = 0 Or NetversionString > 0 Then >> InstallWinPcap.vbs
echo 	NetFlag = False >> InstallWinPcap.vbs
echo Else >> InstallWinPcap.vbs
echo 	IF Is32bitOS = "0" Then>> InstallWinPcap.vbs
echo 		strNetKeyPath = "SOFTWARE\Microsoft\NET Framework Setup\NDP\v1.1.4322" >> InstallWinPcap.vbs
echo	Else>> InstallWinPcap.vbs
echo 		strNetKeyPath = "SOFTWARE\Microsoft\NET Framework Setup\NDP\v1.1.4322" >> InstallWinPcap.vbs
echo 	End If >> InstallWinPcap.vbs
echo 	strNetValueName = "SP" >> InstallWinPcap.vbs
echo 	strNetValueName1 = "DisplayIcon" >> InstallWinPcap.vbs
echo 	oReg.GetDWORDValue HKEY_LOCAL_MACHINE, strNetKeyPath, strNetValueName, NetversionString >> InstallWinPcap.vbs
echo 	oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath, strValueName1, uninstallPath >> InstallWinPcap.vbs
echo End If >> InstallWinPcap.vbs

echo NetFlag = True >> InstallWinPcap.vbs
echo IF NetversionString = 0 Or NetversionString > 0 Then >> InstallWinPcap.vbs
echo 	NetFlag = False >> InstallWinPcap.vbs
echo Else >> InstallWinPcap.vbs
echo End If >> InstallWinPcap.vbs


::if .Net is not already installed, ask user if he wants to install the framework on system or not
echo IF NetFlag = True Then >> InstallWinPcap.vbs
echo 	NetmsgString = "Warning: This application requires .Net 1.1 or .Net 2.0 Framework."  >> InstallWinPcap.vbs
echo 	IfInstallDotNet = APIMsgBox(NetmsgString, 0, ".Net Framework required.") >> InstallWinPcap.vbs
echo.
echo End If >> InstallWinPcap.vbs

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Calling the WinPcap installer script always in 32-bit mode
:: Find out if Win_32 or Win_64
IF "%~1"=="" (SET Computer=%ComputerName%) ELSE (SET Computer=%~1)
IF /I NOT "%Computer%"=="%ComputerName%" (
	PING %Computer% -n 2 2>NUL | FIND "TTL=" >NUL || GOTO Syntax
)
FOR /F "tokens=2 delims==" %%A IN ('WMIC /Node:"%Computer%" Path Win32_Processor Get AddressWidth /Format:list') DO SET OSB=%%A

IF %OSB% EQU 32 goto Win_32
IF %OSB% EQU 64 goto Win_64

: Win_32
:: Calling the 32-bit vbscript interpreter for Win-32 OS (default)
%windir%\system32\cscript.exe //NoLogo InstallWinPcap.vbs
goto Continue_Install

: Win_64
:: Calling the 32-bit vbscript interpreter for Win-64 OS
%windir%\SysWOW64\cscript.exe //NoLogo InstallWinPcap.vbs

:Continue_Install
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Delete the intermediate files
del InstallWinPcap.vbs

:: UnRegister dynwrapx.dll
regsvr32.exe /u /s .\Miscellaneous\dynwrapx.dll

:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Calling the PPU installer
.\Miscellaneous\Setup.exe

echo.
echo.
echo "Task completed. !!!"
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


:InstallationExit
:: End any localizations of environment changes in this script
endlocal

exit /B 0

:FileMissing
echo Some of the installation files are missing. Please copy the files properly before proceeding.
echo Exiting Installer....
pause
exit /B 0
